searchData={"items":[{"type":"behaviour","title":"TwitchEventSub","doc":"The behaviour and implementation of EventSub.","ref":"TwitchEventSub.html"},{"type":"behaviour","title":"Example implementation - TwitchEventSub","doc":"defmodule ExampleHandler do\n      use TwitchEventSub\n\n      @impl TwitchEventSub\n      def handle_event(\"channel.follow\", event) do\n        # Do something with a follow.\n      end\n    end","ref":"TwitchEventSub.html#module-example-implementation"},{"type":"callback","title":"TwitchEventSub.handle_event/2","doc":"Handle events from Twitch EventSub.","ref":"TwitchEventSub.html#c:handle_event/2"},{"type":"module","title":"TwitchEventSub.Plug","doc":"Plug for TwitchEventSub webhooks.","ref":"TwitchEventSub.Plug.html"},{"type":"module","title":"Usage - TwitchEventSub.Plug","doc":"For the plug to work, you need to add the `:raw_body` assign to the `conn`\nwhen your plugs read the body. We provide a custom body reader for you in\n`TwitchEventSub.Plug.BodyReader` and you should use this to read the body.\n\nIf you are using `Phoenix` (and `Plug.Parsers`), then it would look something\nlike this:\n\n    # In Phoenix this would be in MyAppWeb.Endpoint.\n    plug Plug.Parsers,\n      parsers: [:urlencoded, :json],\n      pass: [\"text/*\"],\n      body_reader: {TwitchEventSub.Plug.BodyReader, :read_body, []},\n      json_decoder: Jason\n\nNext, you would use this plug for a Twitch Webhook callback path. Something\nlike this if you are using Phoenix:\n\n    # This passes some application config as the plug options.\n    forward \"/twitch/callback\", TwitchEventSub.Plug, Application.fetch_env!(:my_app, TwitchEventSub)","ref":"TwitchEventSub.Plug.html#module-usage"},{"type":"module","title":"Options (required) - TwitchEventSub.Plug","doc":"* `:webhook_secret` - The secret you pass when you subscribe to an event.\n * `:handler` - The module that implements `TwitchEventSub` to handle events.","ref":"TwitchEventSub.Plug.html#module-options-required"},{"type":"module","title":"TwitchEventSub.Subscriptions","doc":"Twitch API.","ref":"TwitchEventSub.Subscriptions.html"},{"type":"function","title":"TwitchEventSub.Subscriptions.create/3","doc":"Create an eventsub subscription.","ref":"TwitchEventSub.Subscriptions.html#create/3"},{"type":"function","title":"TwitchEventSub.Subscriptions.create_many/5","doc":"Create many Twitch event sub subscriptions.","ref":"TwitchEventSub.Subscriptions.html#create_many/5"},{"type":"function","title":"TwitchEventSub.Subscriptions.list/2","doc":"List all eventsub subscriptions.","ref":"TwitchEventSub.Subscriptions.html#list/2"},{"type":"module","title":"TwitchEventSub.WebSocket","doc":"TwitchEventSub websocket client supervisor.\nSee the `t:option/0` type for the required options.","ref":"TwitchEventSub.WebSocket.html"},{"type":"function","title":"TwitchEventSub.WebSocket.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"TwitchEventSub.WebSocket.html#child_spec/1"},{"type":"type","title":"TwitchEventSub.WebSocket.access_token/0","doc":"Twitch app access token with required scopes for the provided `subscriptions`","ref":"TwitchEventSub.WebSocket.html#t:access_token/0"},{"type":"type","title":"TwitchEventSub.WebSocket.channel_ids/0","doc":"The IDs of the channels we're subscribing to or something.","ref":"TwitchEventSub.WebSocket.html#t:channel_ids/0"},{"type":"type","title":"TwitchEventSub.WebSocket.client_id/0","doc":"Twitch app client id.","ref":"TwitchEventSub.WebSocket.html#t:client_id/0"},{"type":"type","title":"TwitchEventSub.WebSocket.handler/0","doc":"The module that implements `TwitchEventSub`.","ref":"TwitchEventSub.WebSocket.html#t:handler/0"},{"type":"type","title":"TwitchEventSub.WebSocket.keepalive_timeout/0","doc":"The keepalive timeout in seconds. Specifying an invalid, numeric value will\nreturn the nearest acceptable value. Optional. Defaults to `10`.","ref":"TwitchEventSub.WebSocket.html#t:keepalive_timeout/0"},{"type":"type","title":"TwitchEventSub.WebSocket.option/0","doc":"The options accepted (or required) by the Websocket client.","ref":"TwitchEventSub.WebSocket.html#t:option/0"},{"type":"type","title":"TwitchEventSub.WebSocket.start?/0","doc":"Tell the websocket client whether or not it should be started.\nOptional. Defaults to `true`.","ref":"TwitchEventSub.WebSocket.html#t:start?/0"},{"type":"type","title":"TwitchEventSub.WebSocket.subscriptions/0","doc":"The subscriptions for EventSub. Optional. Defaults to a bunch.\nCheck `TwitchEventSub.Websocket.Client` for the defaults.","ref":"TwitchEventSub.WebSocket.html#t:subscriptions/0"},{"type":"type","title":"TwitchEventSub.WebSocket.url/0","doc":"A websocket URL to connect to. Optional.\nDefaults to `\"wss://eventsub.wss.twitch.tv/ws\"`.","ref":"TwitchEventSub.WebSocket.html#t:url/0"},{"type":"type","title":"TwitchEventSub.WebSocket.user_id/0","doc":"The user ID of the broadcaster or bot user we are using for subscriptions.","ref":"TwitchEventSub.WebSocket.html#t:user_id/0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}